import sys
import os
import string
import gzip
import numpy

tolerance = 2.0e-4

def CompareConfigFile(fName):
 
    refFile = gzip.open("TrajectoryFiles_ref/"+fName)
    testFile = gzip.open("TrajectoryFiles/"+fName)
 
    nextLineRef = refFile.readline()
    nextLineTest = testFile.readline()
    listRef = []
    listTest = []
    while nextLineRef:
        nParticles = string.atoi(string.strip(nextLineRef))
        assert nParticles == string.atoi(string.strip(nextLineTest))
        
        refFile.readline()
        testFile.readline()

        for ldx in xrange(nParticles):
            listRef.append(map(string.atof,string.split(refFile.readline())))
            listTest.append(map(string.atof,string.split(testFile.readline())))

        nextLineRef = refFile.readline()
        nextLineTest = testFile.readline()
            
    dataRef = numpy.array(listRef)
    dataTest = numpy.array(listTest)
    diffs = dataTest - dataRef
    return max(diffs.flat)

ok = True
allFiles = os.listdir("TrajectoryFiles_ref")
allFiles.sort()
for filename in allFiles:
    if filename.startswith("block"):
        maxDiff = CompareConfigFile(filename)
        if maxDiff > tolerance:
            print "For file %s, max-difference is %g" % (filename, maxDiff)
            ok = False
            
if ok:
    sys.exit(0)
else:
    sys.exit(1)
    
