#ifndef CONSTRAINTPOTENTIAL_H
#define CONSTRAINTPOTENTIAL_H

/*
  Copyright (C) 2010  Thomas Schrøder
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  LICENSE.txt file for license details.
*/

#include "rumd/RUMD_Error.h"
#include "rumd/BondPotential.h"

class Sample; class Integrator; class MoleculeData;

// Implements holonomic bond constraints into the dynamics.
class ConstraintPotential : public BondPotential{
 private:
  ConstraintPotential(const ConstraintPotential&);
  ConstraintPotential& operator=(const ConstraintPotential&); 

  Sample* S;  
  MoleculeData* M;

  unsigned numberOfMolecules;
  
  unsigned* d_dimLinearSystems;

  float* d_A;
  float* d_b;
  
  float4* d_constraintInfo;
  
  void BuildLinearConstraintSystem();
  void UpdateTotalForce();

 public: 
  ConstraintPotential( MoleculeData* M, Sample* S );
  ~ConstraintPotential();
  
  void CalcF(bool initialize, bool calc_stresses, bool calc_temp, bool calc_bs);
  void WritePotential();
};

#endif // CONSTRAINTPOTENTIAL_H
